'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = init;

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _passportAnonymous = require('passport-anonymous');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = (0, _debug2.default)('feathers-authentication-anonymous');
var defaults = {
  name: 'anonymous'
};

function init() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  return function anonymousAuth() {
    var app = this;
    var _super = app.setup;
    if (!app.passport) {
      throw new Error('Can not find app.passport. Did you initialize feathers-authentication before feathers-authentication-anonymous?');
    }
    var anonymousSettings = Object.assign({}, defaults, options);

    app.setup = function () {
      var result = _super.apply(this, arguments);
      // Register 'anonymous' strategy with passport
      debug('Registering anonymous authentication strategy with option:', anonymousSettings);
      app.passport.use(anonymousSettings.name, new _passportAnonymous.Strategy());
      app.passport.options(anonymousSettings.name, anonymousSettings);

      return result;
    };
  };
}

// Exposed Modules
Object.assign(init, {
  defaults: defaults
});
module.exports = exports['default'];